program Shell_Sort;

{ $BOOTRST $0F000}         {Reset Jump to $0F000}
{$NOSHADOW}
{ $W+ Warnings}            {Warnings off}

Device = mega128, VCC=5;

Import SysTick;

From System Import Random;

Define
        ProcClock   = 16000000;        {Hertz}
        SysTick     = 10;             {msec}
        StackSize   = $0064, iData;
        FrameSize   = $0064, iData;

Implementation

{$IDATA}

{--------------------------------------------------------------}
{ Type Declarations }

type


{--------------------------------------------------------------}
{ Const Declarations }


{--------------------------------------------------------------}
{ Var Declarations }
{$IDATA}
Var
SortWord : Array[0..999] of Word;

{--------------------------------------------------------------}
{ functions }

Procedure Mischen;
Var
  i              : Word;
Begin
  For i := 0 to 999 do
    SortWord[i] := Random;
  end_For;
end;

Procedure Shell_Sort;
Var
i,j, k: Word;
Dummy : Word;
Begin
k := 999 div 2;
While k > 0  do
      For i := 0 to  999 - k  Do
      j:= i;
          While (j >= 0) And (SortWord[j] > SortWord[j+k]) do
          Dummy := SortWord[j];
          SortWord[j] := SortWord[j+k];
          SortWord[j+k]:= Dummy;
             If j > k then
                 j := j-k;
             else
                 j := 0;
             end_If;
          end_While;
      end_for;
      k:=k div 2;
end_while;
end;

{--------------------------------------------------------------}
{ Main Program }
{$IDATA}

begin


  EnableInts;
  Mischen;
  Shell_Sort;

  loop


  endloop;
end Shell_Sort.


