program Sort_Auswahl;

{ $BOOTRST $0F000}         {Reset Jump to $0F000}
{$NOSHADOW}
{ $W+ Warnings}            {Warnings off}

Device = mega128, VCC = 5;

Import SysTick;

From System Import Random;

Define
  ProcClock      = 16000000;        {Hertz}
  SysTick        = 10;             {msec}
  StackSize      = $0064, iData;
  FrameSize      = $0064, iData;

Implementation

{$IDATA}

{--------------------------------------------------------------}
{ Type Declarations }

type


{--------------------------------------------------------------}
{ Const Declarations }


{--------------------------------------------------------------}
{ Var Declarations }
{$IDATA}
Var
  SortWord       : Array[0..999] of Word;

{--------------------------------------------------------------}
{ functions }

Procedure Mischen;
Var
  i              : Word;
Begin
  For i := 0 to 999 do
    SortWord[i] := Random;
  end_For;
end;

Procedure Sort_Auswahl;
Var
  i, j, k, Dummy : Word;
Begin
  For i := 0 to 999 - 1 do
    Dummy := SortWord[i];
    k:= i;
    For j := i + 1 to 999 do
      If SortWord[j] < Dummy then
        Dummy := SortWord[j];
        k := j;
      end_If;
    end_For;
    SortWord[k] := SortWord[i];
    SortWord[i] := Dummy;
  End_For;
end;

{--------------------------------------------------------------}
{ Main Program }
{$IDATA}

begin


  EnableInts;
  Mischen;
  Sort_Auswahl;

  loop


  endloop;
end Sort_Auswahl.


